const chalk = require('chalk')
const webpack = require('webpack')
const WebpackDevServer = require('webpack-dev-server')

module.exports = ({ config, environment }) => {
  const serverConfig = config.toConfig().devServer

  const compiler = webpack(config.toConfig())

  const server = new WebpackDevServer(compiler, serverConfig)

  server.listen(serverConfig.port, serverConfig.host)

  new Promise(() => {
    compiler.hooks.done.tap('dev', (stats) => {
      if (stats.hasErrors()) {
        server.close()
        process.exit(0)
      }

      console.log(
        chalk.cyan(
          ` App running at -${environment}: http://localhost:${serverConfig.port}${serverConfig.publicPath}`
        )
      )
    })
  })
}
