module.exports = ({ config, paths }) => {
  config.module
    .rule('babel')
    .test(/\.(j|t)sx?$/)
    .exclude.add(paths.nodeModules)
    .end()
    .use('babel-loader')
    .loader('babel-loader')
    .options({
      presets: [
        [
          '@babel/preset-env',
          {
            modules: false
          }
        ],
        '@babel/preset-react',
        '@babel/preset-typescript'
      ],
      plugins: [
        [
          '@babel/plugin-transform-runtime',
          {
            corejs: {
              version: 3,
              proposals: true
            },
            useESModules: true
          }
        ],
        '@babel/plugin-syntax-dynamic-import',
        ['@babel/plugin-proposal-decorators', { legacy: true }],
        ['@babel/plugin-proposal-class-properties', { loose: true }],
        [
          'import',
          {
            libraryName: 'antd',
            libraryDirectory: 'es',
            style: true
          }
        ]
      ]
    })
}
