module.exports = ({ config }) => {
  // 打包进度条
  config.plugin('bar').use(require('webpackbar'))

  config.performance
    .hints(false)
    .end()
    .optimization.runtimeChunk({
      name: 'runtime'
    })
    .minimizer('mini-css')
    .use(require('optimize-css-assets-webpack-plugin'))
    .end()
    .splitChunks({
      chunks: 'all',
      cacheGroups: {
        vendors: {
          name: 'vendor',
          test: /[\\/]node_modules[\\/]/,
          priority: -10,
          chunks: 'initial'
        },
        common: {
          name: 'common',
          minChunks: 2,
          priority: -20,
          chunks: 'initial'
        }
      }
    })
}
