const fs = require('fs')
const path = require('path')
const paths = require('./config/paths')
const Config = require('webpack-chain')
const webpackConfig = require('./config/webpack.config')

module.exports = (commandName, environment) => {
  process.env.APP_ENV = environment
  process.env.APP_MODE = commandName === 'start' ? 'development' : 'production'

  const config = new Config()

  const projectConfigPath = path.resolve(process.cwd(), 'webpack.chain.js')

  let projectConfig = null
  if (fs.existsSync(projectConfigPath)) {
    projectConfig = require(projectConfigPath)
  }

  webpackConfig({ config, paths })

  if (typeof projectConfig === 'function') {
    projectConfig(config, process.env.APP_MODE)
  }

  require(`./command/${commandName}`)({ config, paths, environment })
}
